# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.

class ApplicationController < ActionController::Base
    helper :all # include all helpers, all the time

    # Don't log http exception details for these types of errors
    EXCEPTIONS_NOT_LOGGED = ['ActionController::UnknownAction',
                           'ActionController::RoutingError']

    # Prevent some details from showing up in the logs
    filter_parameter_logging :password


    # See ActionController::RequestForgeryProtection for details
    # Uncomment the :secret if you're not using the cookie session store
    protect_from_forgery # :secret => '60e7d925223c0313552730854a4b7134'

    protected

    def log_error(exc)
        super unless EXCEPTIONS_NOT_LOGGED.include?(exc.class.name)
    end

end
