require 'cgi'

class WebsitePaymentStandardController < OrderVerificationController

    PDT_IDENTITY_TOKEN = "ADD YOUR IDENTIFY TOKEN HERE"

    def cart
        return cart_setup
    end
        
    def cart_pdt
        return cart_setup
    end

    def cart_pdt_controller_redirect
        return cart_setup
    end

    def submit_for_controller_redirect_payment
        params = build_order_params(request.parameters["order"])
        path = "https://" + Util.paypal_root + "/us/cgi-bin/webscr"

        url = URI.parse(path)
        req = Net::HTTP::Post.new(url.path)
        req.form_data = params
        http = Net::HTTP.new(Util.paypal_root, 443)
        http.use_ssl = true
        res = http.start { |http| http.request(req) }


        pp_headers = {
                'Cookie' => res.response['set-cookie'],
                'Referer' => path,
                'content-type' => "application/x-www-form-urlencoded"
        }

        res.response.each_key { |key|
            puts key + ": " + res.response[key]
#            pp_headers[key] = res.response[key]
        }

        case res
            when Net::HTTPRedirection
                puts res.response['location']
                res = http.request_get(res.response['location'], pp_headers)
        end

        res.response.each_key { |key|
            puts key + ": " + res.response[key]
        }

        render :text => res.body
    end

    def cart_pdt_dhtml_page_redirect
        return cart_setup
    end

    def cart_pdt_page_redirect
        return cart_setup
    end

    def submit_for_dhtml_page_redirect_payment
        params = build_dhtml_order_params(request.parameters["order"])
        render :inline => build_form(params)
    end
    
    def submit_for_page_redirect_payment
        params = build_order_params(request.parameters["order"])
        render :inline => build_form(params)
    end

    def build_form(params)
        frm = "<html><body><form name='form1' action='https://" + Util.paypal_root + "/cgi-bin/webscr' method='POST'>"
        frm += formify(params)
        frm += "</form></body></html>"
        frm += "<script language='JavaScript'>window.document.form1.submit();</script>"
        frm += "<br/><br/><br/><br/><center>Please wait while Paypal is initialized.</center>"
        return frm
    end

    def formify(params)
        frm = ""
        params.each_key do |key|
            frm += "<input type='hidden' name='" + key + "' value='" + params[key] + "'/>"
        end

        return frm
    end

    def querystringify(params)
        querystring = ""
        params.each_key do |key|
            if querystring.size > 0
                querystring += "&"
            end
            querystring += key + "=" + params[key]
        end

        return querystring
    end

    def close_modal
    end
    
    def close_modal_complete
    end

    def build_dhtml_order_params(order_id)
        params = build_order_params(order_id)
        params["return"] = "http://" + Util.my_domain + "/website_payment_standard/close_modal_complete"
        params["cancel_return"] = "http://" + Util.my_domain + "/website_payment_standard/close_modal"
        return params
    end

    def build_order_params(order_id)

        order = Order.find_by_id(order_id)

        params = {}

        # Transaction level variables
        params["cmd"] = "_cart"
        params["upload"] = "1"
        params["business"] = Util.paypal_business_account.to_s
        params["image_url"] = "http://" + Util.my_domain + "/images/logo.jpg"
        params["page_style"] = "paypal" # Need to create a custom layout for this
        params["no_note"] = "1"
        params["return"] = "http://" + Util.my_domain + "/website_payment_standard/complete_pdt"
        params["rm"] = "0"
        params["cbt"] = "Return to Paypal Test Site"
        params["cancel_return"] = "http://" + Util.my_domain + "/website_payment_standard/cancel"
        params["currency_code"] = "USD"
        params["handling"] = "0" # Handling charges
        params["notify_url"] = "http://10.1.141.88:3000/instant_payment_notification/notify" # The URL paypal will send notification to, behind the scenes

        params["first_name"] = order.customer.first.to_s
        params["last_name"] = order.customer.last.to_s
        params["address1"] = order.customer.address.to_s
        params["city"] = order.customer.city.to_s
        params["state"] = order.customer.state.to_s
        params["zip"] = order.customer.zip.to_s
        params["country"] = order.customer.country.to_s
        params["email"] = order.customer.email.to_s
        params["night_phone_a"] = order.customer.phone.to_s

        params["address_override"] = "1"  # Tells paypal to use the shipping address passed instead of the one they stored

        # Transaction level passthrough variables
        params["custom"] = order.customer.id.to_s
        params["invoice"] = order.id.to_s

        # Item level variables
        i = 1
        for product in order.products

            params["amount_" + i.to_s] = product.price.to_s
            params["item_name_" + i.to_s] = product.name.to_s
            params["quantity_" + i.to_s] = "1"
            params["shipping_" + i.to_s] = product.shipping.to_s
            params["tax_" + i.to_s] = product.tax.to_s
            params["undefined_quantity_" + i.to_s] = "0"
            params["weight_" + i.to_s] = product.weight.to_s
            params["weight_unit_" + i.to_s] = "lbs"

            # Item level passthrough variables
            params["item_number_" + i.to_s] = product.id.to_s

            i += 1
        end

        return params
    end

    def cart_setup
        destroy(Product.find(:all))
        destroy(Customer.find(:all))
        destroy(Order.find(:all))

        customer = Customer.new
        customer.first = "Mike"
        customer.last = "Jarvis"
        customer.address = "123 Fake Street"
        customer.city = "Jacksonville"
        customer.state = "FL"
        customer.zip = "32216"
        customer.country = "United States"
        customer.phone = "904-456-8973"
        customer.email = "asdsfffdfdff@mjvlks.com"
        customer.save

        @order = Order.new
        @order.price = 0
        @order.weight = 0
        @order.customer = customer
        @order.products = []
        @order.save

        i = rand(5) + 1
        while (i > 0)
            product = Product.new
            product.name = "Random Product " << i.to_s
            product.description = "Description for Random Product " << i.to_s
            product.created_date = '2009-01-01'
            product.price = rand(15) + 15
            product.weight = rand(3) / 2
            product.tax = product.price * 0.07

            if product.weight * 0.30 > 5
                product.shipping = product.weight * 0.30
            else
                product.shipping = 5
            end

            product.save

            i = i - 1

            @order.price += product.price
            @order.weight += product.weight
            @order.products << product
        end

        @order.save

        return @order
    end

    def confirm
    end

    def cancel
    end

    def complete

        @order = verify_order(request.parameters)

        if @order.nil?

            # Send some emails out flagging this as tampered/invalid
            # WRITE ME!
        end


    end

    def complete_pdt

        post_params = {
                "cmd" => "_notify-synch",
                "tx" => request.parameters["tx"],
                "at" => PDT_IDENTITY_TOKEN
        }


        # We need to POST this data to Paypal in order to get the details of the transaction
        url = URI.parse("http://" + Util.paypal_root + "/cgi-bin/webscr")
        res = Net::HTTP.post_form(url, post_params)
        res_val = CGI.unescape(res.body)

        logger.info "Response:" + res_val

        if res_val == "FAIL"
            # TODO - handle this!
            return
        end

        # Parse the response out into a usable hash
        params = {}
        lines = res_val.split("\n")
        for line in lines
            if line.include?("=")
                key, value = line.split("=")
                params[key.lstrip.rstrip] = value.lstrip.rstrip
            end
        end

        @order = verify_order(params)

        if @order.nil?

            # Send some emails out flagging this as tampered/invalid
            # WRITE ME!
        end

    end

    private

    def destroy(collection)
        if !collection.nil?
            collection.each {|item|
                item.destroy
            }
        end
    end
end
