class Order < ActiveRecord::Base
    belongs_to :customer
    has_many :products

    def shipping
        amt = 0
        if !products.nil?
            for product in products
                if !product.shipping.nil?
                    amt += product.shipping
                end
            end
        end
        return amt
    end

    def subtotal
        price
    end

    def total
        price + self.tax + self.shipping + self.handling
    end

    def price
        amt = 0
        if !products.nil?
            for product in products
                if !product.price.nil?
                    amt += product.price
                end
            end
        end
        return amt
    end

    def tax
        amt = 0
        if !products.nil?
            for product in products
                if !product.tax.nil?
                    amt += product.tax
                end
            end
        end
        return amt
    end

    def handling
        amt = 0
        if !products.nil?
            for product in products
                if !product.handling.nil?
                    amt += product.handling
                end
            end
        end
        return amt
    end
end
