class CreateOrders < ActiveRecord::Migration
  def self.up
    create_table :orders do |t|
      t.decimal :price
      t.decimal :weight
      t.references :customer
      t.string :pp_txn_id
      t.float :pp_txn_fee
      t.string :pp_receipt_id
      t.string :pp_protection_eligible
      t.string :payment_type
      t.string :pp_auth
      t.float :authorization_amount
      t.date :authorization_expires
      t.string :authorization_id
      t.string :authorization_status
      t.string :exchange_rate
      t.string :payer_status
      t.float :remaining_settle
      t.float :settle_amount
      t.string :settle_currency
      t.string :transaction_entity
      t.date :dispute_case_creation_date
      t.string :dispute_case_id
      t.string :dispute_case_type
      t.string :payment_status
      t.boolean :pending, :null => false, :default => true
      t.string :pending_reason, :null => true, :limit => 4000
      t.boolean :risky, :null => false, :default => false
      t.string :risky_details, :null => true, :limit => 4000

      t.timestamps
    end
  end

  def self.down
    drop_table :orders
  end
end
