class CreateProducts < ActiveRecord::Migration
  def self.up
    create_table :products do |t|
      t.string :name, :null => false, :limit => 200
      t.string :description, :null => false, :limit => 4000
      t.date :created_date, :null => true
      t.float :price, :null => false
      t.float :weight, :null => true
      t.string :payment_status, :null => true
      t.float :shipping, :null => true
      t.float :tax, :null => true
      t.float :handling, :null => true
      t.string :txn_id, :null => true, :limit => 400
      t.integer :quantity, :null => false, :default => 1
      t.references :order

      t.timestamps
    end
  end

  def self.down
    drop_table :products
  end
end
